.nolist

UseAlign16 = 1	; makes Lingo's algo work

useMB = 0		; makes RevString2+3 dramatically faster
ife useMB
	include \masm32\include\masm32rt.inc	; http://www.masm32.com/board/index.php?topic=12460
else
	include \masm32\MasmBasic\MasmBasic.inc
endif
.686
.xmm
include \masm32\macros\timers.asm			; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 1000000-1

.data
; Src	db "x", 0	; strings with len<2 let szRev crash
if UseAlign16
  align 16
else
  padd	db 0,0,0, 0	; Lingo's algo doesn't like that
endif
Src	db "This is a string, 100 characters long, that serves a variety of purposes, such as testing my algos..", 0	; comment 0 to get 500 bytes
	db "This is a string, 100 characters long, that serves a variety of purposes, such as testing my algos.."
	db "This is a string, 100 characters long, that serves a variety of purposes, such as testing my algos.."
	db "This is a string, 100 characters long, that serves a variety of purposes, such as testing my algos.."
	db "This is a string, 100 characters long, that serves a variety of purposes, such as testing my algos..", 0
.code
start:	push 1
	call ShowCpu	; print brand string and SSE level
	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call RevString
	counter_end
	print str$(eax), 9, "cycles for RevString", 13, 10
	if useMB
		PrintLine Left$(offset Src, 78)
	endif

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call RevString2a
	counter_end
	print str$(eax), 9, "cycles for RevString2a", 13, 10
	if useMB
		PrintLine Left$(offset Src, 78)
	endif

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call RevString2b
	counter_end
	print str$(eax), 9, "cycles for RevString2b", 13, 10
	if useMB
		PrintLine Left$(offset Src, 78)
	endif

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call RevString3
	counter_end
	print str$(eax), 9, "cycles for RevString3", 13, 10
	if useMB
		PrintLine Left$(offset Src, 78)
	endif

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call RevStr
	counter_end
	print str$(eax), 9, "cycles for RevStr", 13, 10
	if useMB
		PrintLine Left$(offset Src, 78)
	endif

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src	; twice, yes
		push offset Src
		call szRev1
	counter_end
	print str$(eax), 9, "cycles for szRev1", 13, 10
	if useMB
		PrintLine Left$(offset Src, 78)
	endif

if UseAlign16
	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call RevLingo
	counter_end
	print str$(eax), 9, "cycles for RevLingo (needs aligned strings)", 13, 10
endif

	push offset Src	; twice, yes
	push offset Src
	call szRev1
	print chr$(10)
	print offset Src, 13, 10, 10

	print chr$(13, 10, "Sizes:", 13, 10)
	mov eax, RevString_e
	sub eax, RevString_s
	print str$(eax), 9, "RevString", 13, 10
	mov eax, RevString2a_e
	sub eax, RevString2a_s
	print str$(eax), 9, "RevString2a", 13, 10
	mov eax, RevString2b_e
	sub eax, RevString2b_s
	print str$(eax), 9, "RevString2b", 13, 10
	mov eax, RevString3_e
	sub eax, RevString3_s
	print str$(eax), 9, "RevString3", 13, 10
	mov eax, RevStr_e
	sub eax, RevStr_s
	print str$(eax), 9, "RevStr", 13, 10
	mov eax, szRev_e
	sub eax, szRev_s
	print str$(eax), 9, "szRev", 13, 10
	mov eax, RevLingo_e
	sub eax, RevLingo_s
	print str$(eax), 9, "RevLingo", 13, 10
	inkey chr$(13, 10, "--- ok ---", 13)
	exit

align 16
RevString_s:
RevString proc
	push esi
	push edi
	mov esi, [esp+4+8]
	if 1
		invoke StrLen, esi
		lea edi, [esi+eax]		; you must know the end of the string
	else
		lea edi, [esi+len(esi)]	; you must know the end of the string - but szLen is slow
	endif
	shr eax, 3				; len div 8 - we use dwords and meet in the middle
	je @F
	.Repeat
		sub edi, 4
		mov ecx, [esi]
		mov edx, [edi]
		bswap ecx
		bswap edx
		mov [edi], ecx
		mov [esi], edx
		add esi, 4
		dec eax
	.Until Zero?
@@:	dec edi
	cmp edi, esi
	jbe @F
	movzx eax, byte ptr [esi]
	movzx edx, byte ptr [edi]
	mov [esi], dl
	mov [edi], al
	inc esi
	jmp @B
@@:	pop edi
	pop esi
	ret 4
RevString endp
RevString_e:

align 16
RevString2a_s:
RevString2a proc
	push esi
	push edi
	mov esi, [esp+4+8]
	ife useMB
		invoke StrLen, esi
		lea edi, [esi+eax-4]		; you must know the end of the string
	else
		lea edi, [esi+Len(esi)-4]	; you must know the end of the string - but szLen is slow
	endif
	cmp eax, 4
	jb @F
	.Repeat
	if 1	; 64 bytes
		mov edx, [edi]
		lodsd
		bswap edx
		mov [esi-4], edx
		bswap eax
		mov [edi], eax
		sub edi, 4
	else	; 67 bytes
		mov edx, [edi]
		mov eax, [esi]
		bswap eax
		bswap edx
		mov [edi], eax
		mov [esi], edx
		sub edi, 4
		add esi, 4
	endif
	.Until edi<esi
@@:	add edi, 4
@@:	dec edi
	cmp edi, esi
	jbe @F
	mov al, byte ptr [esi]
	mov dl, byte ptr [edi]
	mov [esi], dl
	mov [edi], al
	inc esi
	jmp @B
@@:	pop edi
	pop esi
	ret 4
RevString2a endp
RevString2a_e:

align 16
RevString2b_s:
RevString2b proc
	push esi
	push edi
	mov esi, [esp+4+8]
	ife useMB
		invoke StrLen, esi
		lea edi, [esi+eax-4]		; you must know the end of the string
	else
		lea edi, [esi+Len(esi)-4]	; you must know the end of the string - but szLen is slow
	endif
	cmp eax, 4
	jb @F
	.Repeat
	if 0	; 64 bytes
		mov edx, [edi]
		lodsd
		bswap edx
		mov [esi-4], edx
		bswap eax
		mov [edi], eax
		sub edi, 4
	else	; 67 bytes
		mov edx, [edi]
		mov eax, [esi]
		bswap eax
		bswap edx
		mov [edi], eax
		mov [esi], edx
		sub edi, 4
		add esi, 4
	endif
	.Until edi<esi
@@:	add edi, 4
@@:	dec edi
	cmp edi, esi
	jbe @F
	mov al, byte ptr [esi]
	mov dl, byte ptr [edi]
	mov [esi], dl
	mov [edi], al
	inc esi
	jmp @B
@@:	pop edi
	pop esi
	ret 4
RevString2b endp
RevString2b_e:

align 16
RevString3_s:
RevString3 proc
	push esi
	push edi
	mov esi, [esp+4+8]
	ife useMB
		invoke StrLen, esi
		lea edi, [esi+eax-4]		; you must know the end of the string
	elseif 0
		mov edi, esi
		xor eax, eax
		or ecx, -1
		repne scasb	; very slow, adds 300 cycles
		xchg eax, ecx
		neg eax
		sub eax, 2
		sub edi, 5
	else
		lea edi, [esi+Len(esi)-4]	; you must know the end of the string - but szLen is slow
	endif
	cmp eax, 4
	jb @F
	.Repeat
	if 0	; 64 bytes
		if 0
			mov edx, [edi]
			bswap edx
			mov eax, [esi]
			mov [esi], edx
			bswap eax
			add esi, 4
			mov [edi], eax
		else
			mov edx, [edi]
			lodsd
			bswap edx
			mov [esi-4], edx
			bswap eax
			mov [edi], eax
		endif
		sub edi, 4
	else	; 67 bytes
		mov edx, [edi]
		mov eax, [esi]
		bswap eax
		bswap edx
		mov [edi], eax
		mov [esi], edx
		sub edi, 4
		add esi, 4
	endif
	.Until edi<esi
@@:	add edi, 4
@@:	dec edi
	cmp edi, esi
	jbe @F
	mov al, byte ptr [esi]
	mov dl, byte ptr [edi]
	mov [esi], dl
	mov [edi], al
	inc esi
	jmp @B
@@:	pop edi
	pop esi
	ret 4
RevString3 endp
RevString3_e:

align 16
RevStr_s:
RevStr  proc
        push    edi
        push    esi
	if 1
	       mov     esi, [esp+4+8]
		invoke StrLen, esi
		lea edi, [esi+eax]		; you must know the end of the string
	else
	       mov     edi, [esp+4+8]
		mov     esi, edi
        		add     edi, len(edi)                ; you must know the end of the string
	endif
        shr     eax, 3                       ; len div 8 - we use dwords and meet in the middle
        jz      RevSt2

RevSt0: sub     edi,4
        mov     ecx, [esi]
        mov     edx, [edi]
        bswap   ecx
        bswap   edx
        mov     [edi], ecx
        mov     [esi], edx
        dec     eax
        lea     esi, [esi+4]
        jnz     RevSt0

        jmp short RevSt2

RevSt1: movzx   edx, byte ptr [edi]
        movzx   eax, byte ptr [esi]
        mov     [esi],dl
        mov     [edi],al
        inc     esi

RevSt2: dec     edi
        cmp     edi,esi
        ja      RevSt1

        pop     esi
        pop     edi
        ret     4
RevStr  endp
RevStr_e:

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16
szRev_s:
szRev1 proc src:DWORD,dst:DWORD

  ; ------------------------------------
  ; this version will reverses a string
  ; in a single memory buffer so it can
  ; accept the same address as both src
  ; and dst.
  ; ------------------------------------

    push esi
    push edi

    mov esi, [esp+4][8]     ; src
    mov edi, [esp+8][8]     ; dst
    xor eax, eax            ; use EAX as a counter

  ; ---------------------------------------
  ; first loop gets the buffer length and
  ; copies the first buffer into the second
  ; ---------------------------------------
 ;   @@:
 ;     movzx edx, BYTE PTR [esi+eax]       ; copy source to dest
 ;     ;; mov [edi+eax], dl
 ;     add eax, 1                          ; get the length in EAX
 ;     test edx, edx
 ;     jne @B

    invoke StrLen, esi
    cmp eax, 1
    jbe TooShort

    mov esi, [esp+8][8]                 ; put dest address in ESI
    mov edi, esi                        ; same in EDI
    ; sub eax, 1                          ; correct for exit from 1st loop <<<<<<<<<<< little bug
    lea edi, [edi+eax-1]                ; end address in edi
    shr eax, 1                          ; int divide length by 2
    neg eax                             ; invert sign
    sub esi, eax                        ; sub half len from ESI

  ; ------------------------------------------
  ; second loop swaps end pairs of bytes until
  ; it reaches the middle of the buffer
  ; ------------------------------------------
  @@:
    movzx ecx, BYTE PTR [esi+eax]       ; load end pairs
    movzx edx, BYTE PTR [edi]
    mov [esi+eax], dl                   ; swap end pairs
    mov [edi], cl
    sub edi, 1
    add eax, 1
    jnz @B                              ; exit on half length

    ;; mov eax, dst                     ; return destination address
TooShort:
    pop edi
    pop esi

    ret 8

szRev1 endp
szRev_e:

align 16
RevLingo_s:
db	 9 Dup(0cch)
RevLingo proc          ; lpBuffer:dword [url=http://www.masm32.com/board/index.php?topic=14041.msg111377#msg111377]thread[/url]
				pop				edx
				pop				ecx
				pxor			xmm0, xmm0
				mov				eax, ecx
@@:
				pcmpeqb	xmm0, [ecx]
				add				ecx, 16
				pmovmskb	edx, xmm0
				test				edx, edx
				jz					@b
				sub				ecx,	eax
				bsf				edx,	edx
				lea				edx,	[ecx+edx-16]
				cmp				edx, 4
				jb					Bytes3
				push			ebx
@@:
				mov				ecx, [eax]
				add				eax,	4
				bswap			ecx
				add				edx,	-8
				mov				ebx,	 [eax+edx]
				mov				[eax+edx], ecx
				bswap			ebx
				mov				[eax-4], ebx
				jg					@b
				pop				ebx
				jmp				dword ptr [esp-2*4]
Bytes3:
				movzx			ecx, byte  ptr [eax]
				cmp				edx, 1
				mov				byte ptr [eax+edx-1], cl
				jbe				@f
				mov				cl, byte  ptr [eax+1]
				cmp				edx, 2
				mov				byte ptr [eax+edx-2], cl
				jbe				@f
				mov				cl, byte  ptr [eax+2]
				mov				byte ptr [eax+edx-3], cl
@@:
				jmp				dword ptr [esp-2*4]
RevLingo endp 
RevLingo_e:

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp


end start

Intel(R) Pentium(R) 4 CPU 3.40GHz (SSE3)
306     cycles for RevString
345     cycles for RevString2a
219     cycles for RevString2b
221     cycles for RevString3
220     cycles for RevStr
375     cycles for szRev1
175     cycles for RevLingo (needs aligned strings)

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]
